//+------------------------------------------------------------------+
//|                                                Synthetic VIX.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  PaleVioletRed
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int    VIXPeriod           = 22;
extern int    VIXPrice            = PRICE_CLOSE;
extern double Smooth              = 5;
extern double SmoothPhase         = 0;
extern bool   ShowAsStochastic    = false;
extern int    StochasticPeriod    = 14;
extern int    StochasticLevelUp   = 80;
extern int    StochasticLevelDown = 20;
extern bool   ShowBands           = false;
extern int    BandsPeriod         = 14;
extern double BandsDeviations     =  2;

//
//
//
//
//

double vix[];
double vixUp[];
double vixDn[];
double vixw[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,vix);
      SetIndexBuffer(1,vixUp);
      SetIndexBuffer(2,vixDn);
      SetIndexBuffer(3,vixw);
      SetIndexBuffer(4,prices);

      //
      //
      //
      //
      //
      
      if (ShowAsStochastic)
      {
         SetLevelValue(0,StochasticLevelUp);
         SetLevelValue(1,StochasticLevelDown);
      }
      else
      {
         SetLevelValue(0,EMPTY);
         SetLevelValue(1,EMPTY);
      }         
   //
   //
   //
   //
   //
   
   string addName = ""; if (ShowAsStochastic) addName = "Stochastic ";
   IndicatorShortName(addName+"Synthetic VIX ("+VIXPeriod+")");
   return(0);
}
int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,VIXPrice,i);
      
         //
         //
         //
         //
         //
         
         prices[i] = price;
            double highest = prices[ArrayMaximum(prices,VIXPeriod,i)];
         vixw[i] = 100.0*(highest-Low[i])/highest;
         
         //
         //
         //
         //
         //
         
         if (ShowAsStochastic)
         {
            double min = vixw[ArrayMinimum(vixw,StochasticPeriod,i)];
            double max = vixw[ArrayMaximum(vixw,StochasticPeriod,i)];
            double sto = 0;
               if (min!=max) sto = 100.0*(vixw[i]-min)/(max-min);
               vix[i] = iSmooth(sto,Smooth,SmoothPhase,i);
         }
         else  vix[i] = iSmooth(vixw[i],Smooth,SmoothPhase,i);
         
         //
         //
         //
         //
         //
         
         if (ShowBands)
         {
            double mean = vix[i];
               for (k=1; k<BandsPeriod; k++) mean += vix[i+k]; mean /= BandsPeriod;
            double devs = 0;
               for (k=0; k<BandsPeriod; k++) devs += MathPow(vix[i+k]-mean,2); devs = MathSqrt(devs/BandsPeriod);
            vixUp[i] = mean+BandsDeviations*devs;
            vixDn[i] = mean-BandsDeviations*devs;
         }
   }      
   return(0);
}  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}